"""
    Scrapes abcnews.go.com
    for headlines and corresponding urls
    @date: 2019-11-25
"""

import requests
import lxml
import bs4
import re
import json

print('Grabbing headlines from ABC')

content_url = 'https://abcnews.go.com/'
base_url = content_url
file_name = 'data/abcnews.json'
media_identifier = 'abcnews'
counter = 0
data = []

html = requests.get(content_url) # read the url
soup = bs4.BeautifulSoup(html.text, 'lxml') # create a DOM-like object
anchors = soup.select('ul.headlines-ul a')

for a in anchors:
    counter += 1
    if not a['href'] == 'javascript:void(0);' and not a['href'].startswith('https://abcnews.go.com/Entertainment/'):
        x = {
            'id': counter,
            'source': media_identifier,
            'url': a['href'],
            'title': a.text
        }
        data.append(x)

with open(file_name, 'w', encoding='utf-8') as f:
    json.dump(data, f, ensure_ascii=False, indent=4)
