"""
    Scrapes bbc.com/news
    for headlines and corresponding urls
    @date: 2019-11-25
"""

import requests
import lxml
import bs4
import re
import json

print('Grabbing headlines from BBC')

content_url = 'https://www.bbc.com/news'
base_url = 'https://bbc.com'
file_name = 'data/bbc.json'
media_identifier = 'bbc'
counter = 0
data = []

forbidden_paths = ['http', 'sms', '/sport/', '/news/entertainment-arts-']
forbidden_text = ['Global Trade', 'Global Education', 'Entrepreneurship', 'Technology of Business', 'Connected World', 'Election 2019']

html = requests.get(content_url) # read the url
soup = bs4.BeautifulSoup(html.text, 'lxml') # create a DOM-like object
anchors = soup.find_all('a')

for a in anchors:
    counter += 1
    # Skipping first entry since it tends to be a duplicate of the 2nd entry
    if counter > 2 and re.search('\d$', a['href']) and not a['href'].startswith(tuple(forbidden_paths)) and not a.text.startswith(tuple(forbidden_text)):
        x = {
            'id': counter,
            'source': media_identifier,
            'url': base_url + a['href'],
            'title': a.text
        }
        data.append(x)

with open(file_name, 'w', encoding='utf-8') as f:
    json.dump(data, f, ensure_ascii=False, indent=4)
