"""
	Read News from berliner_zeitung.de's RSS feeds
	Berliner_zeitung.de hosts multiple feeds
"""
import feedparser
import re
import json

print('Grabbing headlines from Berliner Zeitung')

# Digital
digital_url = 'http://www.berliner-zeitung.de/blueprint/servlet/xml/berliner-zeitung/23700594-asYahooFeed.xml'
# Wissen
wissen_url = 'http://www.berliner-zeitung.de/blueprint/servlet/xml/berliner-zeitung/23700222-asYahooFeed.xml'
# Wirtschaft
wirtschaft_url = 'http://www.berliner-zeitung.de/blueprint/servlet/xml/berliner-zeitung/23699644-asYahooFeed.xml'
# Politik
politik_url = 'http://www.berliner-zeitung.de/blueprint/servlet/xml/berliner-zeitung/23699614-asYahooFeed.xml'
# Berlin
berlin_url = 'http://www.berliner-zeitung.de/blueprint/servlet/xml/berliner-zeitung/23699382-asYahooFeed.xml'

feed_urls = [digital_url, wissen_url, wirtschaft_url, politik_url, berlin_url]

file_name = 'data/berliner_zeitung.json'
media_identifier = 'bz'
regex_pattern = '\.de\/[a-zA-Z]+\/'
counter = 1
data = []

for url in feed_urls:
	feed = feedparser.parse(url)
	for post in feed.entries:
		category = re.search(regex_pattern, post.link)
		x = {
			'id': counter,
			'source': media_identifier,
			'url': post.link,
			'title': post.title,
			'category': str(category.group(0)).replace('.de/', '').replace('/', ''),
			'published': post.published
		}
		data.append(x)
		counter += 1

with open(file_name, 'w', encoding='utf-8') as f:
    json.dump(data, f, ensure_ascii=False, indent=4)
