"""
    Grab headlines and links
    from Golem.de's RSS-feed
"""

import feedparser
import re
import json

print('Grabbing headlines from Golem')

url = 'https://rss.golem.de/rss.php?feed=RSS1.0'
file_name = 'data/golem.json'
media_identifier = 'golem'
feed = feedparser.parse(url)
counter = 1
data = []

for post in feed.entries:
    x = {
        'id': counter,
        'source': media_identifier,
        'url': post.link,
        'title': post.title,
        'published': post.date
    }
    data.append(x)

with open(file_name, 'w', encoding='utf-8') as f:
    json.dump(data, f, ensure_ascii=False, indent=4)
