"""
    Scrapes msnbc.com
    for headlines and corresponding urls
    @date: 2019-11-25
"""

import requests
import lxml
import bs4
import re
import json

print('Grabbing headlines from MSNBC')

content_url = 'https://www.msnbc.com'
base_url = content_url
file_name = 'data/msnbc.json'
media_identifier = 'msnbc'
counter = 0
data = []

html = requests.get(content_url) # read the url
soup = bs4.BeautifulSoup(html.text, 'lxml') # create a DOM-like object
anchors = soup.select('h3 a')

for a in anchors:
    counter += 1
    x = {
        'id': counter,
        'source': media_identifier,
        'url': a['href'],
        'title': a.text
    }
    data.append(x)

with open(file_name, 'w', encoding='utf-8') as f:
    json.dump(data, f, ensure_ascii=False, indent=4)
