"""
	Crawls subreddits according to the list in the code
	using the reddit API
	and saves essential information in a separate .json file for each subreddit
	@date: 2019-11-18
"""
import json
import requests
from datetime import datetime

# Reddit API Connection details
APP_SECRET = 'your-api' # bot.2 - script
REDDIT_USERNAME = 'your-reddit-username'
REDDIT_PASSWORD = 'your-password'
USER_AGENT = 'Redditbot by devawbot'

reddit_url = 'https://old.reddit.com/'
data = {'grant_type': 'password', 'username': REDDIT_USERNAME, 'password': REDDIT_PASSWORD}
auth = requests.auth.HTTPBasicAuth(APP_ID, APP_SECRET)
r = requests.post(
	reddit_url + 'api/v1/access_token',
	data=data,
	headers={'user-agent': USER_AGENT},
	auth=auth
)
d = r.json()

token = 'bearer ' + d['access_token']
auth_url = 'https://oauth.reddit.com'
auth_url_path = '/api/v1/me'
headers = {'Authorization': token, 'User-Agent': USER_AGENT}

try:
	response = requests.get(auth_url + auth_url_path, headers=headers)
except requests.exceptions.Timeout:
    print(e)
except requests.exceptions.TooManyRedirects:
    print(e)
except requests.exceptions.RequestException as e:
    print(e)
    sys.exit(1)

if response.status_code == 200:
	print('Connection established. Getting data.')
	subreddits = ['programming', 'programmerhumor', 'webdev', 'coding', 'python', 'java', 'javascript', 'php']
	for sub in subreddits:
		db_data = []
		url = '/r/' + sub + '/hot'
		payload = {'limit': '20'}
		response = requests.get(auth_url + url, headers=headers, params=payload)
		if response.status_code == 200:
			data = response.json
			file_name = 'data/reddit_' + sub + '.json'
			print('=> Grabbing ' + url)
			response_dict = json.loads(response.text)
			dict = response_dict['data']['children']
			for d in dict:
				created = str(datetime.fromtimestamp(d['data']['created_utc']))
				item = {
					'id': d['data']['score'], # need to use something
					'category': d['data']['subreddit'],
					'title': d['data']['title'],
					'source': sub,
					# 'permalink': d['data']['permalink'],
					'url': d['data']['url'],
					'created': created,
					# 'score': d['data']['score'],
					# 'thumbnail': d['data']['thumbnail']
				}
				db_data.append(item)

			print('------------')
			with open(file_name, 'w', encoding='utf-8') as f:
			    json.dump(db_data, f, ensure_ascii=False, indent=4)

		else:
			pass # skip and don't overwrite files
else:
	pass

print('Done.')
