"""
	Sueddeutsche.de
"""

import feedparser
import re
import json

print('Grabbing headlines from Sueddeutsche')

url = 'https://rss.sueddeutsche.de/app/service/rss/alles/index.rss?output=rss'
file_name = 'data/sueddeutsche.json'
media_identifier = 'sueddeutsche'
regex_pattern = '\.de\/[a-zA-Z]+\/'
counter = 1
data = []
feed = feedparser.parse(url)

for post in feed.entries:
	category = re.search(regex_pattern, post.link)
	x = {
		'id': counter,
		'source': media_identifier,
		'url': post.link,
		'title': post.title,
		'category': str(category[0]).replace('.de/', '').replace('/', ''),
		'published': post.published
	}
	data.append(x)
	counter += 1

with open(file_name, 'w', encoding='utf-8') as f:
    json.dump(data, f, ensure_ascii=False, indent=4)
